#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <string>
#include "puntuacion.h"
using namespace std;

const int Puntuacion::puntosNivel[5] = {1, 5, 10, 20, 50};

Puntuacion::Puntuacion(){
	reiniciarPuntuacion();
	cargarRecords();
}

void Puntuacion::sumarAcierto(int nivel){
	aciertosNivel[nivel-1]++;
}

void Puntuacion::reiniciarPuntuacion(){
	int i;
	for(i=0;i<5;i++){
		aciertosNivel[i]=0;
	}
}

int Puntuacion::getAciertos(int nivel){
	return aciertosNivel[nivel-1];
}

int Puntuacion::getPuntosPNivel(int nivel){
	return puntosNivel[nivel-1];
}

int Puntuacion::getPuntos(){
	int i, aciertos, punt;
	int num=0;
	for(i=1;i<=5;i++){
		aciertos=getAciertos(i);
		punt=getPuntosPNivel(i);
		num=num+aciertos*punt;
	}
	return num;
}

double Puntuacion::getPuntosPS(int seg){
	int punt;
	double num;
	punt=getPuntos();
	num=(double)punt/seg;
	return num;
}

void Puntuacion::cargarRecords(){
	int i=0;
	string file="puntuaciones";
	string line;
	ifstream fi;
	fi.open(file.c_str(), ios::in);
	if (fi.is_open()){
		getline(fi,line);
		while (!fi.eof()){
			records[i][0]=extraerNumero(line, 1);
			records[i][1]=extraerNumero(line, 2);
			i++;
			getline(fi,line);
		}
		fi.close();
	}
}


string Puntuacion::extraerCadena(string cadena, int pos){
	int i;
	int unsigned ini=0;
	int unsigned end=0;
		for (i=0;i<=pos;i++){
			if(end!=cadena.length()){
				if(end!=0)
					ini=end+1;
				if(cadena.find('#', ini)==string::npos)
					end=cadena.length();
				else
					end=cadena.find('#', ini);
			}else
				cadena="";
		}
	if(cadena!="")
			cadena=cadena.substr(ini, end-ini);
	return(cadena);
}

int Puntuacion::extraerNumero(string cadena, int pos){
	int num;
	string texto;
	texto=extraerCadena(cadena, pos);
	num=atoi(texto.c_str());
	return num;
}

bool Puntuacion::actualizarRecords(int puntos, int tiempo, int categoria){
	bool encontrado=false;
	int i;
	int pos=-1;
	int fin=categoria*10-1;
	int ini=fin-9;
	if(records[fin][0]<puntos || (records[fin][0]==puntos && records[fin][1]>tiempo)){
		for(i=(fin-1);i>=ini;i--){
			if(records[i][0]<puntos){
				records[i+1][0]=records[i][0];
				records[i+1][1]=records[i][1];
			}else if(records[i][0]==puntos && records[i][1]>tiempo){
				records[i+1][0]=records[i][0];
				records[i+1][1]=records[i][1];
			}else if(encontrado==false){
				encontrado=true;
				pos=i;
			}
		}
		if(pos<0)
			pos=ini-1;
		records[pos+1][0]=puntos;
		records[pos+1][1]=tiempo;
		grabarRecords();
	}
	return encontrado;
}

void Puntuacion::grabarRecords(){
	int i, j;
	string line="";
	ofstream fo;
	fo.open("puntuaciones", ios::out);
	if (fo.is_open()){
		for(i=0;i<40;i++){
				fo << i/10+1 << '#'<< records[i][0] << '#' << records[i][1];
			fo << endl;
		}
		fo.close();
	}
}

void Puntuacion::reiniciarRecords(int juego){
	int i;
	int ini=0;
	int fin=40;
	if(juego>0){
		fin=juego*10;
		ini=fin-10;
	}
	for(i=ini;i<fin;i++){
		records[i][0]=0;
		records[i][1]=0;
	}
	grabarRecords();
}

void Puntuacion::mostrarPuntuacion(int tiempo){
	int i, num;
	do{
		system("clear");
		cout << "\n\n     **********************\n";
		cout << "        PUNTOS OBTENIDOS\n";
		cout << "     **********************\n\n";
		cout << "     Nivel     Nº aciertos     Puntos\n";
		for(i=0;i<5;i++){
			cout << "       "<< i+1 << "            " << aciertosNivel[i] << "          ";
			cout << aciertosNivel[i] << " x " << puntosNivel[i] << " = " <<aciertosNivel[i]*puntosNivel[i] << endl;
		}
		cout << "                                Total: " << getPuntos() << endl;
		cout << "                           Puntos/Seg: " << getPuntosPS(tiempo) << "\n\n";
		cout << "     1. Volver";
		cout << "     Elija una opción: ";
		cin >> num;
	}while(num!=1);
}
